<?php

// jrfc_ConverterClassT_jjmw
// by mouser@donationcoder.com, mar 1. 2010
//
// this file defines the jjrfc_ConverterClassT_mwiki class which extends the mediawiki converter class

// base class file
require_once('jrfconvert_converterclass_mwiki.php');




class jrfc_ConverterClassT_jjmw extends jrfc_ConverterClassT_mwiki
{

//---------------------------------------------------------------------------
function __construct()
{
	// derived constructor
	// call parent constructor
	parent::__construct();
}
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
function GetDefaultOptions()
{
	// start with parents defaults
	$defaultoptions = parent::GetDefaultOptions();

	// this will be used if not overridden by commandline
	$defaultoptions['filepatterns']='*.html,*.htm,*.png,*.gif,*.jpg';
	$defaultoptions['excludepatterns']='*_print.*,bullet_*,blank*';
	//
	$defaultoptions['mw_unprotect']=1;
	$defaultoptions['mw_overwriteimg']=1;
	$defaultoptions['mw_overwritepage']=1;
	//
	// this causes us to save ".wiki2" files (result after massaging) to help debug
	$defaultoptions['mw_savewiki2']=1;
	//
	return $defaultoptions;
}
//---------------------------------------------------------------------------














//---------------------------------------------------------------------------
function mw_MassageWikiFileText(&$fileo)
{
	// given first rought draft wiki file text, massage it and do any changes to it

	// first let base class massage
	parent::mw_MassageWikiFileText($fileo);


	//echo ' IN jj MASSAGE' . "\n";

	// input
	$contents=$fileo['contents'];
	$fname=$fileo['fname'];
	$fname_fullpath=$fileo['fname_fullpath'];
	$fname_relpath=$fileo['fname_relpath'];
	$extension=$fileo['extension'];


	// convert image maps
	// incoming format:
	/*
	<imagemap>ImageRef:controlmap|id=controlmap</imagemap></center>
		rect 50 91 82 123 [[#id_1]]
	rect 51 320 83 352 [[#id_2]]
	rect 223 18 255 50 [[#id_3]]
	rect 274 345 306 377 [[#id_4]]
	rect 343 2 375 34 [[#id_5]]
	rect 387 316 419 348 [[#id_6]]
	rect 459 37 491 69 [[#id_7]]
	rect 506 374 538 406 [[#id_8]]
	rect 615 19 647 51 [[#id_9]]
	rect 615 350 647 382 [[#id_10]]
	rect 720 56 752 88 [[#id_11]]
	[[Image:screen_2_2.png|Heightfield clip vertical|usemap=#controlmap]]
	//
	// change to
	//	
	<imagemap>Image:screen_2_2.png|Heightfield clip vertical
	rect 50 91 82 123 [[#id_1]]
	rect 51 320 83 352 [[#id_2]]
	rect 223 18 255 50 [[#id_3]]
	rect 274 345 306 377 [[#id_4]]
	rect 343 2 375 34 [[#id_5]]
	rect 387 316 419 348 [[#id_6]]
	rect 459 37 491 69 [[#id_7]]
	rect 506 374 538 406 [[#id_8]]
	rect 615 19 647 51 [[#id_9]]
	rect 615 350 647 382 [[#id_10]]
	rect 720 56 752 88 [[#id_11]]
	</imagemap></center>
	*/
	//

	if (false)
		{
		// OLD STUFF

		// imagemap conversion
		$regexpat = '/\<imagemap\>ImageRef\:(.*?)\<\/imagemap\>(.*?)(rect.*?)\[\[(Image.*?)\|usemap=(.*?)\]\]/s';
		$contents = preg_replace_callback($regexpat,array(&$this,'preg_callback_imagemapfix'),$contents);
	
	
		// annoying font fix
		// <font color="#000000"><font size="11pt"><font face="Arial">
	//	$regexpat = '/\<font color="#000000"\>\<font size="11pt"\>\<font face="Arial"\>(.*?)\<\/font\>\<\/font\>\<\/font\>/s';
	//	$contents = preg_replace($regexpat,'\\1',$contents);
		//
		// more font hell
		$find = '<div align="right"><font size="8pt">[#top [Top]]</font></div>';
		$contents = str_replace($find,'',$contents);
		$find = '<div align="right"><font size="8pt">[[|[Top]]]</font></div>';
		$contents = str_replace($find,'',$contents);
		//
	
		// more annoying font fixes
		$regexpat = '/\<font color="([A-Za-z0-9_#-]*?)"\>\<font size="([A-Za-z0-9_#-]*?)"\>\<font face="([A-Za-z0-9_#-]*?)"\>(.*?)\<\/font\>\<\/font\>\<\/font\>/s';
		$contents = preg_replace($regexpat,'\\4',$contents);
		//
	
		// big textfont fix
		$regexpat = '/\<font size="([A-Za-z0-9_#-]*?)"\>\<font color="([A-Za-z0-9_#-]*?)"\>(.*?)\<\/font\>\<\/font\>/s';
		$contents = preg_replace($regexpat,'\\3',$contents);
	
	
		// eliminate bullet images
		$regexpat = '/\[\[\#top\|\[\[Image\:bullet.*?\.png\|(.*?)\s\..*?\]\]\]\]/s';
		$contents = preg_replace($regexpat,'\\1. ',$contents);
		//
		$regexpat = '/\[\[\|\[\[Image\:bullet.*?\.png\|(.*?)\s\..*?\]\]\]\]/s';
		$contents = preg_replace($regexpat,'\\1. ',$contents);
		//
		// menu bullets
		$regexpat = '/\[\[Image\:bullet_.*?\.gif\]\]/s';
		$contents = preg_replace($regexpat,'',$contents);
		//
		// blank line bullet *
		$find = "\r\n* \r\n";
		$rep = "\r\n* ";
		$contents = str_replace($find,$rep,$contents);
	
	
		// print, prev, next
		$regexpat = '/\{\| id="TablePrint".*?\|\}/s';
		$contents = preg_replace($regexpat,'',$contents);
		// print, prev, next
		$regexpat = '/\{\| id="Table3".*?\|\}/s';
		$contents = preg_replace($regexpat,'',$contents);
	
		// top page crap
		$regexpat = "/\<center\>''''''\<\/center\>/s";
		$contents = preg_replace($regexpat,'',$contents);
	
		// end page
		$regexpat = '/|-(\s*?)\| class="pagearea".*?\|\}/s';
		$contents = preg_replace($regexpat,'',$contents);
	
		// bot page crap
		$regexpat = "/\<center\>''''''\<br \/\>\<\/center\>/s";
		$contents = preg_replace($regexpat,'',$contents);
	
		// fixup page valign
		$find = 'class="page_area" width="100%"';
		$rep = 'class="page_area" width="100%" valign="top"';
		$contents = str_replace($find,$rep,$contents);
	
		// annoying top link
		$find = '|-' . "\r\n" . '|' . "\r\n" . '<div align="right"><font size="8pt">[[#top|[Top]]]</font></div>';
		$rep = '';
		$contents = str_replace($find,$rep,$contents);
		}



	// NEW--------

	// jj - strip all font codes - start
	$regexpat = '/\<font ([^>]+)\>/s';
	$contents = preg_replace($regexpat,'',$contents);
	// jj - strip all font codes - end
	$regexpat = '/\<\/font\>/s';
	$contents = preg_replace($regexpat,'',$contents);


	// jj -- remove imagemap stuff
	$regexpat = '/\|usemap\=\#([^\]]+?)\]/s';
	$contents = preg_replace($regexpat,']',$contents);
	// jj - strip all font codes - end


	// jj - strip all span codes - start
	$regexpat = '/\<span ([^>]+)\>/s';
	$contents = preg_replace($regexpat,'',$contents);
	// jj - strip all span codes - end
	$regexpat = '/\<\/span\>/s';
	$contents = preg_replace($regexpat,'',$contents);

	// jj - strip br codes - start
	$regexpat = '/\<br \/\>/s';
	$contents = preg_replace($regexpat,'',$contents);


	// jj - strip top stuff codes - start
	$regexpat = '/\[\[\#top\|\]\]\s*/s';
	$contents = preg_replace($regexpat,'',$contents);

	// jj - strip all font codes - start
	$regexpat = '/\<imagemap\>([^>]+)\<\/imagemap\>/s';
	$contents = preg_replace($regexpat,'',$contents);

	// jj - strip all rect codes - start
	$regexpat = '/\s*rect (.*?)\]\]\s*/m';
	$contents = preg_replace($regexpat,'',$contents);

	// jj - strip table crap
	$regexpat = '/\|\-\s*\|\s*\[\[\#top\|\[Top\]\]\]\s*\|\s*\}/s';
	$contents = preg_replace($regexpat,'',$contents);
	// jj - strip table crap
	$regexpat = '/\|\-\s*\|\s*\[\[\#top\|\[Top\]\]\]\s*\|\-\s*\|/s';
	$contents = preg_replace($regexpat,'',$contents);

	// jj - strip table crap
	$regexpat = '/\{\| id\=\"(.*?)\s*\|/s';
	$contents = preg_replace($regexpat,'',$contents);


	// jj - strip table crap2
	$regexpat = '/[\r\n]\{\|[^\[]*\[/s';
	$contents = preg_replace($regexpat,'[',$contents);
	$regexpat = '/\|\}[\r\n]/s';
	$contents = preg_replace($regexpat,'',$contents);


	// jj - strip ondocumentloaded crap
	$regexpat = '/\s*onDocumentLoaded\(\);/s';
	$contents = preg_replace($regexpat,'',$contents);


	// jj - fucking painful to have to do so much kludging back and forth
	$regexpat = '/\<nowiki\>\* \<\/nowiki\>/s';
	$contents = preg_replace($regexpat,'* ',$contents);
     



	// jj better linespacing for headings
#	$regexpat = '/[a-zA-Z0-9\.\,]+\s+(\'\'\')/s';
#	$contents = preg_replace($regexpat,"\n\n".'\\1',$contents);
#	$regexpat = '/\.\s+(\'\'\')/s';
#	$contents = preg_replace($regexpat,"\n\n".'\\1',$contents);


	// ok NOW we are going to try to do something fancy and replace links to filenames to their cached title names
	// ie change [[window_2_2|Heightfield clip vertical]]
	// to [[Window: Heightfield clip vertical | Heightfield clip vertical]]
	$regexpat = '/\[\[([^\]]*?)\|([^\]]*?)\]\]/s';
	$contents = preg_replace_callback($regexpat,array(&$this,'preg_callback_linknamefix'),$contents);


	// auto link to parents who have filenames or title names that are a prefix of ours
	if ($this->options['mw_autoparent']!==0)
		{
		$closestparenttitle = $this->FindClosestParentTitle($fileo);
		if ($closestparenttitle!='')
			{
			$contents .= "\n" . 'Back to: [[' . $closestparenttitle . ']]' . "\n";
			}
		}


	// add special word saying not to show built in mediawiki table of contents box
	$contents .= '__NOTOC__' . "\n";


	// let's add a comment about what file it came from?
	$contents .= '<!-- imported from file: ' . $fname_relpath . '-->' . "\n";



	// ok now latstly we MUST save it back into the file object
	$fileo['contents']=$contents;

	// return TRUE saying no error
	return TRUE;
}
//---------------------------------------------------------------------------










//---------------------------------------------------------------------------
function preg_callback_linknamefix($matches)
{
	// ok NOW we are going to try to do something fancy and replace links to filenames to their cached title names
	// ie change [[window_2_2|Heightfield clip vertical]]
	// to [[Window: Heightfield clip vertical | Heightfield clip vertical]]


	$filenametitle=$matches[1];
	$label=$matches[2];

	// look for filename in chache
	$fileo_cached = $this->find_cachedfileo_bywikifilenamelink($filenametitle);
	//echo 'looking for cache of ' . $relfname . "\n";
	if ($fileo_cached!==NULL)
		{
		// found it -- use cached pagetitle
		if (!empty($fileo_cached['mwpagetitle']))
			{
			$filenametitle = $fileo_cached['mwpagetitle'];
			}
		}

	if ($filenametitle==$label)
		{
		// same
		return '[[' . $filenametitle . ']]';
		}

	return '[[' . $filenametitle . '|' . $label . ']]';
}
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
function mw_titleFromFile_Real($fileo)
{
	// title is not cached -- lets's try to get it from file <h1>
	// or else fall back on mw lexical default

	// get file contents (temporary)
	$fname = $fileo['fname_fullpath'];
	$fcontents = file_get_contents($fname);
	// now look for title heuristic
	// <title>Window: Scalar to Boolean scalar</title>
	$regexpat = '/\<title\>(.*?)\<\/title\>/i';
	$matches=array();
	$matchretv = preg_match($regexpat,$fcontents,$matches);
	if (isset($matches[1]))
		{
		$titlename = $matches[1];
		// periods to something else?
		$titlename = $this->mw_correctbadfile2wikicharacters($titlename);
		//$titlename = str_replace(' ','_',$titlename);
		return $titlename;
		}

	return parent::mw_titleFromFile_Real($fileo);
}
//---------------------------------------------------------------------------













//---------------------------------------------------------------------------
function mw_PreprocessHtmlFile_Modify(&$fileo,&$htmlcontents)
{
	// modify contents or do nothing
	// return false to abort conversin of file

	// first base class method
	parent::mw_PreprocessHtmlFile_Modify($fileo,$htmlcontents);

	// now our custom stuff


	// ok how do we want to modify it?
	//echo 'IN MOD AND WRITE' . "\n";

	// jj - strip all meta codes - start
	$regexpat = '/\<meta ([^>]+)\>/s';
	$htmlcontents = preg_replace($regexpat,'',$htmlcontents);
	// jj - strip all p codes - end
	$regexpat = '/\<\/meta\>/s';
	$htmlcontents = preg_replace($regexpat,'',$htmlcontents);

	// jj - strip all meta codes - start
	$regexpat = '/\<script ([^>]+)\>/s';
	$htmlcontents = preg_replace($regexpat,'',$htmlcontents);
	// jj - strip all script codes - end
	$regexpat = '/\<\/script\>/s';
	$htmlcontents = preg_replace($regexpat,'',$htmlcontents);


	// jj - strip between <body> and <h1>
	$regexpat = '/\<body\>(.*?)\<h1/s';
	$htmlcontents = preg_replace($regexpat,'<body><h1',$htmlcontents);

	// jj - strip all font codes - start
	$regexpat = '/\<font ([^>]+)\>/s';
	$htmlcontents = preg_replace($regexpat,'',$htmlcontents);
	// jj - strip all font codes - end
	$regexpat = '/\<\/font\>/s';
	$htmlcontents = preg_replace($regexpat,'',$htmlcontents);


	// jj - strip all div codes - start
	$regexpat = '/\<div ([^>]+)\>/s';
	$htmlcontents = preg_replace($regexpat,'<p>',$htmlcontents);
	// jj - strip all div codes - end
	$regexpat = '/\<\/div\>/s';
	$htmlcontents = preg_replace($regexpat,'</p>',$htmlcontents);

	if (false)
		{
		// jj - strip all p codes - start
		$regexpat = '/\<p ([^>]+)\>/s';
		$htmlcontents = preg_replace($regexpat,'',$htmlcontents);
		// jj - strip all p codes - end
		$regexpat = '/\<\/p\>/s';
		$htmlcontents = preg_replace($regexpat,"",$htmlcontents);
		}
	else
		{
		// jj - strip all p codes - start
		$regexpat = '/\<p ([^>]+)\>/s';
		$htmlcontents = preg_replace($regexpat,'<p>',$htmlcontents);
		// jj - strip all p codes - end
		$regexpat = '/\<\/p\>/s';
		$htmlcontents = preg_replace($regexpat,'</p>',$htmlcontents);
		}


	// jj - fix bullet newlines
	$regexpat = '/[\r\n]\* [\r\n]/s';
	$htmlcontents = preg_replace($regexpat,"* ",$htmlcontents);
	$regexpat = '/[\r\n]\* [\r\n]/s';
	$htmlcontents = preg_replace($regexpat,"* ",$htmlcontents);




	// jj - fix p newlines
	$regexpat = '/[\r\n]\<p\>[\r\n]/s';
	$htmlcontents = preg_replace($regexpat,"\n<p>",$htmlcontents);
	$regexpat = '/[\r\n]\<p\>[\r\n]/s';
	$htmlcontents = preg_replace($regexpat,"\n<p>",$htmlcontents);
	// jj - fix p newlines
	$regexpat = '/[\r\n]\<\/p\>[\r\n]/s';
	$htmlcontents = preg_replace($regexpat,"</p>\n",$htmlcontents);
	$regexpat = '/[\r\n]\<\/p\>[\r\n]/s';
	$htmlcontents = preg_replace($regexpat,"</p>\n",$htmlcontents);


	// jj - strip all bullet graphics
	$regexpat = '/\<img ([^>]+)\"bullet([^>]+)[\s\r\n]*\>/s';
	$htmlcontents = preg_replace($regexpat,'* ',$htmlcontents);

	// jj - fix bullet newlines
	$regexpat = '/\<p\>\* [\r\n]/s';
	$htmlcontents = preg_replace($regexpat,"<p>* ",$htmlcontents);
	$regexpat = '/\<p\>\* [\r\n]/s';
	$htmlcontents = preg_replace($regexpat,"<p>* ",$htmlcontents);




	// jj - strip end stuff
	$regexpat = '/\<td class=\"pagearea\"(.*?)\<\/body\>/s';
	$htmlcontents = preg_replace($regexpat,'</body>',$htmlcontents);

	// jj - end stuff 2
	$regexpat = '/\<\/td\>\s*\<\/tr\>\s*\<tr\>\s*\<\/body\>/s';
	$htmlcontents = preg_replace($regexpat,'</body>',$htmlcontents);

	// jj - fucked up thing
	$regexpat = '/\&\#160;/s';
	$htmlcontents = preg_replace($regexpat,'',$htmlcontents);

	return true;
}
//---------------------------------------------------------------------------
















//---------------------------------------------------------------------------
function FindClosestParentTitle($fileo)
{
	// return the page title of the immediate parent to this file, or '' if not found

	// what is our pagetitle

	$ourfileo = $this->get_cachedfileo($fileo);
	if ($ourfileo===NULL)
		{
		// not found
		return '';
		}

	$ourtitle = $ourfileo['mwpagetitle'];
	$bestlen = 0;
	$besttitle = '';

	if ($ourtitle=='')
		{
		//echo '%%% CURRENT PAGE TITLE NOT FOUND CANT LOOK FOR PARENT' . "\n";
		return '';
		}

	foreach ($this->filenametitlemap as $onefnamemap)
		{
		$candidatetitle = $onefnamemap['mwpagetitle'];
		if ($candidatetitle != $ourtitle && strpos($ourtitle,$candidatetitle)===0)
			{
			if (strlen($candidatetitle)>$bestlen)
				{
				// got one
				$besttitle = $candidatetitle;
				$bestlen = strlen($candidatetitle);
				}
			}
		}

	if ($besttitle!='')
		{
		//echo '%%%%%%%%%%%%%%%%%%%%%%%%%% FOUND PARENT OF ' . $ourtitle . ' IS ' . $besttitle . "\n";
		}

	return $besttitle;
}
//---------------------------------------------------------------------------




















}