<?php

// jrfc_ConverterClassT_mwiki
// by mouser@donationcoder.com, mar 1. 2010
//
// this file defines the jjrfc_ConverterClassT_mwiki class which extends the main converter class


// base class file
require_once('jrfconvert_converterclass.php');




class jrfc_ConverterClassT_mwiki extends jrfc_ConverterClassT
{
	// 
	protected $def_extentions_image = array('gif','png','jpg','jpeg','svg');
	protected $def_extentions_html = array('htm','html');
	protected $def_extentions_plainttext = array('txt');
	//
	protected $last_linkfixing_fileo = NULL;


//---------------------------------------------------------------------------
function __construct()
{
	// derived constructor
	// call parent constructor
	parent::__construct();
}
//---------------------------------------------------------------------------








//---------------------------------------------------------------------------
function GetDefaultOptions()
{
	// start with parents defaults
	$defaultoptions = parent::GetDefaultOptions();

	// this will be used if not overridden by commandline
	// files that we will attempt to import as html, text, or image
	$defaultoptions['filepatterns']='*.html,*.htm,*.png,*.gif,*.jpg';
	// files or subdirectory patterns to skip
	$defaultoptions['excludepatterns']='';
	//
	$defaultoptions['mw_unprotect']=1;
	// overwrite images or pages found -- ATTN: if set to 0, entries with same name will be SKIPPED
	$defaultoptions['mw_overwriteimg']=1;
	$defaultoptions['mw_overwritepage']=1;
	//
	// this causes us to save ".wiki2" files (result after massaging) to help debug
	$defaultoptions['mw_savewiki2']=1;
	//
	// options to add wiki text to top or bottom of every imported page
	$defaultoptions['mw_header']='';
	$defaultoptions['mw_footer']='';
	// ATTN: not finished -- ability to set custom prefix on page titles
	$defaultoptions['mw_titleprefix']='';
	// adds [[CATEGORY]] tag
	$defaultoptions['mw_category']='IMPORT';
	// comment added to edits
	$defaultoptions['mw_comment']='jrfconvert import';
	// set this to bypass revision control updates that preserver prior versions
	$defaultoptions['mw_norc']=0;
	// set this to auto link to parents whose file names or title names are proper prefixes
	$defaultoptions['mw_autoparent']=1;
	//
	return $defaultoptions;
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
function Init_Prepare()
{
	// parent init
	$retv=parent::Init_Prepare();
	if ($retv==FALSE)
		return $retv;

	// now our derived init -- any media wiki stuff to check

	// include commandLine.inc
	$mwdir = $this->globalfydir($this->options['mwdir'],$this->options['basedir']);
	//
	$fname_comlineinc = $mwdir . '/maintenance/commandLine.inc';
	$fname_importimagesinc = $mwdir . '/maintenance/importImages.inc.php';
	if (!file_exists($fname_comlineinc))
		{
		echo 'FATAL ERROR: Could not find mediawiki file (please specifify -mwdir= option): ' . $fname_comlineinc . "\n";
		return FALSE;
		}
	if (!file_exists($fname_importimagesinc))
		{
		echo 'FATAL ERROR: Could not find mediawiki file (please specifify -mwdir= option): ' . $fname_importimagesinc . "\n";
		return FALSE;
		}
	//
	// now schedule include of commandline helper file
	global $global_Options;
	$global_Options['globalrequires'][]=$fname_comlineinc;
	$global_Options['globalrequires'][]=$fname_importimagesinc;

	// change working directory
	//	chdir($mwdir);
	return TRUE;
}


function Init_Final()
{
	// parent init
	$retv=parent::Init_Final();
	if ($retv==FALSE)
		return $retv;

	//echo 'Successfully initialized MediaWiki converter class.' . "\n";
	return TRUE;
}
//---------------------------------------------------------------------------




























//---------------------------------------------------------------------------
function GetTempFilePatterns()
{
	// return temp file patterns to delete or "" for none,
	// should be comma separated like so: '*.wiki,*.wiki2,*.preprocessed'

	// get parent list
	$cleanpatterns = parent::GetTempFilePatterns();

	// add out custom list
	if ($cleanpatterns!="")
		$cleanpatterns .= ',';
 	$cleanpatterns .= '*.wiki,*.wiki2,*.htm4wiki,*.html4wiki';

	// return it
	return $cleanpatterns;
}
//---------------------------------------------------------------------------














//---------------------------------------------------------------------------
function ProcessFile($fileo)
{
	// process the file
	//
	$retv=$this->mw_ImportFile($fileo);
	//
	// update stats
	if ($retv)
		{
		$this->options['stat_files_success']+=1;
		}
	else
		{
		$this->options['stat_files_failed']+=1;
		}
}
//---------------------------------------------------------------------------
















//---------------------------------------------------------------------------
function mw_ImportFile($fileo)
{
	// import a file based on its type

	$extension=$fileo['extension'];
	if ($extension=='')
		{
		$this->AddToLog(array('type'=>'warning','text'=>'skipping import of file because of missing extension.'));
		return FALSE;
		}

	// image files get processed without loading their contents by us
	if (in_array($extension,$this->def_extentions_image))
		{
		// import it
		return $this->mw_ImportFile_As_Image($fileo);
		}

	// html files get converted to mediawiki text, then added
	if (in_array($extension,$this->def_extentions_html))
		{
		// pre-process by loading file contents
		$this->LoadFileContentsForFileo($fileo);
		// import it
		return $this->mw_ImportFile_As_Html($fileo);
		}

	// html files get converted to mediawiki text, then added
	if (in_array($extension,$this->def_extentions_plainttext))
		{
		// pre-process by loading file contents
		$this->LoadFileContentsForFileo($fileo);
		// import it
		return $this->mw_ImportFile_As_PlainText($fileo);
		}

	// unknown
	$this->AddToLog(array('type'=>'warning','text'=>'skipping import of file because of no rule to handle file extension (' . $extension . ').'));
	return FALSE;
}
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
function mw_ImportFile_As_PlainText(&$fileo)
{
	// assume it is already in mediawiki format
	return $this->mw_ImportFile_As_MediaWiki_ArticleText($fileo);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function mw_ImportFile_As_Html(&$fileo)
{
	// first preprocess html file into a modified html (make sure not to use .html extension!)
	// second CONVERT html to mediawiki text

	$retv=$this->mw_PreprocessHtmlFile($fileo);
	if (!$retv)
		return FALSE;

	// second CONVERT html to mediawiki text
	$retv=$this->mw_ConvertFileContentsFromHtmlToMediaWikiText($fileo);
	if (!$retv)
		return FALSE;

	// now massage the mediawiki text
	$retv=$this->mw_MassageWikiFileText($fileo);
	if (!$retv)
		return FALSE;

	// write out to new final file after massaging
	$retv=$this->mw_SaveMassagedWikiFileText($fileo);
	if (!$retv)
		return FALSE;

	// then add it
	return $this->mw_ImportFile_As_MediaWiki_ArticleText($fileo);
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
function mw_ImportFile_As_Image(&$fileo)
{
	return $this->mw_ImportFile_As_MediaWiki_Image($fileo);
}
//---------------------------------------------------------------------------
















































//---------------------------------------------------------------------------
function mw_ImportFile_As_MediaWiki_ArticleText(&$fileo)
{
	// import some page text into mediawiki
	//  from ./mediawiki/maintenance/importTextFile.php

	$fname=$fileo['fname'];
	$fname_fullpath=$fileo['fname_fullpath'];
	$fname_relpath=$fileo['fname_relpath'];
	$extension=$fileo['extension'];
	$text=$fileo['contents'];
	//
	$finalretv=FALSE;

	// ATTN: test
	$options=$this->options;

	if( is_file( $fname_fullpath ) ) {

		$title = isset( $options['mw_title'] ) ? $options['mw_title'] : $this->mw_titleFromFile( $fileo );
		$title = Title::newFromUrl( $title );

		if( is_object( $title ) ) {


			if( !$title->exists() || $this->arraypropenabled($options,'mw_overwritepage') ) {

				$user = isset( $options['mw_user'] ) ? $options['mw_user'] : 'Maintenance script';
				$user = User::newFromName( $user );

				if( is_object( $user ) ) {

					//echo( "\nUsing username '" . $user->getName() . "'..." );
					$wgUser =& $user;
					$comment = isset( $options['mw_comment'] ) ? $options['mw_comment'] : 'Importing text file';
					$flags = 0 | (( $this->arraypropenabled($options,'mw_norc')==TRUE ) ? EDIT_SUPPRESS_RC : 0 );

					//echo( "\nPerforming edit..." );
					$article = new Article( $title );
					$article->doEdit( $text, $comment, $flags );
					$this->AddInfoToLog(' imported page as article title "' . $title . '"');
					//echo( "done.\n" );
					$finalretv=TRUE;

				} else {
					echo( " ERROR: invalid username.\n" );
					$finalretv=FALSE;
				}

			} else {
				$this->AddInfoToLog(' skipped import since page (' . $title .') exists and mw_overwrite=0.');
				$finalretv=FALSE;
			}

		} else {
			$this->AddInfoToLog(' skipped import since page (' . $title .') title is invalid.');
			$finalretv=FALSE;
		}

	} else {
		echo( "does not exist.\n" );
		$finalretv=FALSE;
	}

	return $finalretv;
}
//---------------------------------------------------------------------------









//---------------------------------------------------------------------------
function mw_ImportFile_As_MediaWiki_Image(&$fileo)
{
	// import image file
	//  from ./mediawiki/maintenance/importImages.php

	$fname=$fileo['fname'];
	$fname_fullpath=$fileo['fname_fullpath'];
	$fname_relpath=$fileo['fname_relpath'];
	$extension=$fileo['extension'];
	//
	$finalretv=FALSE;

	//
	$skipped=0;
	$overwritten=0;
	$added=0;

	// ATTN: test
	$options=$this->options;


	# Check Protection
	if ($this->arraypropenabled($options,'mw_protect') && $this->arraypropenabled($options,'mw_unprotect'))
			die("Cannot specify both protect and unprotect.  Only 1 is allowed.\n");
	//if (!isset($options['mw_protect']))
			//die("You must specify a protection option.\n");


	# set the array of files to add to this one file
	$files = array($fname_fullpath);


	# Initialise the user for this operation
	$user = isset( $options['mw_user'] )
		? User::newFromName( $options['mw_user'] )
		: User::newFromName( 'Maintenance script' );
	if( !$user instanceof User )
		$user = User::newFromName( 'Maintenance script' );
	$wgUser = $user;

	# Get the upload comment
	$comment = 'Importing image file';

	if ( isset( $options['mw_comment-file'] ) ) {
		$comment =  file_get_contents( $options['mw_comment-file'] );
		if ( $comment === false || $comment === NULL ) {
			die( "failed to read comment file: {$options['mw_comment-file']}\n" );
		}
	}
	else if ( isset( $options['mw_comment'] ) ) {
		$comment =  $options['mw_comment'];
	}

	$commentExt = isset( $options['mw_comment-ext'] ) ? $options['mw_comment-ext'] : false;

	# Get the license specifier
	$license = isset( $options['mw_license'] ) ? $options['mw_license'] : '';

	# Batch "upload" operation
	if( ( $count = count( $files ) ) > 0 ) {
	
		foreach( $files as $file ) {


			if (false)
				{
				// old way was to use BASE filename (use filename no extension) as TITLE of image, new way uses our smarter unique title naming
				$base = wfBaseName( $file );
				}
			else
				{
				$fileo_cached = $this->get_cachedfileo($fileo);
				$base = $fileo_cached['mwpagetitle'];
				//echo '----> USING image title: ' . $base;
				}

			// ATTN: unfinished -- process basename to do custom image titles
	
			# Validate a title
			$title = Title::makeTitleSafe( NS_FILE, $base );
			if( !is_object( $title ) ) {
				$this->AddInfoToLog(' skipped image import since page (' . $title .') is invalid.');
				continue;
			}
	
			# Check existence
			$image = wfLocalFile( $title );
			if( $image->exists() ) {
				if( $this->arraypropenabled($options,'mw_overwriteimg') ) {
					$this->AddInfoToLog(' image imported over existing file.');
					$svar = 'overwritten';
				} else {
					$this->AddInfoToLog(' image import skipped since file already exists and mw_overwrite=0.');
					$this->options['stat_files_skipped']+=1;
					$skipped++;
					continue;
				}
			} else {
				$this->AddInfoToLog(' new image imported.');
				$svar = 'added';
			}

			# Find comment text
			$commentText = false;

			if ( $commentExt ) {
				$f = findAuxFile( $file, $commentExt );
				if ( !$f ) {
					//echo( " No comment file with extension {$commentExt} found for {$file}, using default comment. " );
				} else {
					$commentText = file_get_contents( $f );
					if ( !$f ) {
						echo( " Failed to load comment file {$f}, using default comment. " );
					}
				}
			}

			if ( !$commentText ) {
				$commentText = $comment;
			}

			# Import the file	
			if ( $this->arraypropenabled($options,'mw_dry') ) {
				$this->AddInfoToLog(' dry run of import -- no changed made.');
				echo( " dry-run simulating publishing {$file}... " );
			} else {
				$archive = $image->publish( $file );
				if( WikiError::isError( $archive ) || !$archive->isGood() ) {
					$this->AddErrorToLog(' import failed.');
					$finalretv=FALSE;
					continue;
				}
			}
			
			$doProtect = false;
			$restrictions = array();
			
			global $wgRestrictionLevels;
			
			$protectLevel = isset($options['mw_protect']) ? $options['mw_protect'] : null;
			
			if ( $protectLevel && in_array( $protectLevel, $wgRestrictionLevels ) ) {
					$restrictions['move'] = $protectLevel;
					$restrictions['edit'] = $protectLevel;
					$doProtect = true;
			}
			if ($this->arraypropenabled($options,'mw_unprotect')) {
					$restrictions['move'] = '';
					$restrictions['edit'] = '';
					//$doProtect = true;
					$doProtect = false;
			}


			$$svar++;
			if ( $this->arraypropenabled($options,'mw_dry') ) {
				{
				$finalretv=TRUE;
				}
			} else if ( $image->recordUpload( $archive->value, $commentText, $license ) ) {
				# We're done!
				$this->AddInfoToLog(' image imported as "' . $title . '"');
				$finalretv=TRUE;
				//
				if ($doProtect) {
						# Protect the file
						$article = new Article( $title );
						$this->AddInfoToLog(' protection requires waiting for mediawiki slaces, waiting...');
						// Wait for slaves.
						sleep(2.0);
						wfWaitForSlaves( 1.0 );

						if ( $article->updateRestrictions($restrictions) )
								{
								$this->AddInfoToLog(' updated protection restrictions.');
								$finalretv=TRUE;
								}
						else
								{
								$this->AddErrorToLog(' failed to updatie protection restrictions.');
								$finalretv=FALSE;
								}
				}

			} else {
				$this->AddErrorToLog(' failed to import image file.');
				$finalretv=FALSE;
			}
			
		}
		
		# Print out some statistics
		foreach( array( 'count' => 'Found', 'added' => 'Added',
			'skipped' => 'Skipped', 'overwritten' => 'Overwritten' ) as $var => $desc ) {
//			if( $$var > 0 )
//				echo( "{$desc}: {$$var}\n" );
		}
		
	} else {
		//$this->AddErrorToLog(' No suitable files found to import.');
		//echo( "No suitable files could be found for import.\n" );
		$finalretv=FALSE;
	}

	return $finalretv;
}
//---------------------------------------------------------------------------








































//---------------------------------------------------------------------------
function mw_ConvertFileContentsFromHtmlToMediaWikiText(&$fileo)
{
	// modify contents to convert html to mediawiki text
	$contents=$fileo['contents'];
	$fname=$fileo['fname'];
	$fname_fullpath=$fileo['fname_fullpath'];
	$fname_relpath=$fileo['fname_relpath'];
	$extension=$fileo['extension'];

	// we can process a modified re-rewritten html instead of original
  if (isset($fileo['fname_fullpath_inputhtml']))
		{
		$fname_fullpath_inputhtml=$fileo['fname_fullpath_inputhtml'];
    //echo '---> Using modified html file: ' . $fname_fullpath_inputhtml . "\n";
		}
	else
		{
		$fname_fullpath_inputhtml=$fname_fullpath=$fileo['fname_fullpath'];
		}

	// options
	$deletewikifileafter=$this->options['deletetempfiles'];

	// convert
	
	// use shell method
	if (true)
		{
		$fname_fullpath_wikiout = $fname_fullpath . '.wiki';
		$fileo['fname_fullpath_wikiout'] = $fname_fullpath_wikiout;
		$htmltowikipl_path = dirname(__FILE__) . '/tools/html2wiki.pl';
		// delete if exists
		if (file_exists($fname_fullpath_wikiout))
			{
			unlink($fname_fullpath_wikiout);
			}

		// build commandline
		$comline = '';

		// windows needs perl.exe
		if ($this->jrfc_iswindowsos())
			$comline .= 'perl.exe';
		else
			$comline .= 'perl';
		//
		$comline .= ' "' . $htmltowikipl_path . '"';

		if (isset($this->options['mwdialect']))
			$comline .= ' --dialect=' . $this->options['mwdialect'];
		else
			{
			// default dialect
			//$comline .= ' --dialect=MediaWiki';
			$comline .= ' --dialect=MediaWikiTb';
			}

//		$comline .= ' --preserve-nowiki 1';
		$basereldir = $this->options['curdir_relative'];
		//$comline .= ' --basereldir="' . $basereldir .'"';
//		$comline .= ' --base-uri="' . $basereldir .'"';
		$comline .= ' "' . $fname_fullpath_inputhtml . '"';
		$comline .= ' > "' . $fname_fullpath_wikiout . '"';

		// shell it
		$retv = shell_exec($comline);
		//
		if ($this->isdebugmode())
			{
			echo 'DEBUG: SHELLED ' . $comline . "\n";
			echo 'DEBUG: SHELL RESULT = ' . $retv . "\n";
			}

		// failure?
		if (!file_exists($fname_fullpath_wikiout))
			{
			// failure
			return FALSE;
			}
		if (filesize($fname_fullpath_wikiout)==0)
			{
			// failure
			unlink($fname_fullpath_wikiout);
			return FALSE;
			}

		$contents = file_get_contents($fname_fullpath_wikiout);

		// delete after creation?
		if ($deletewikifileafter!==0)
			{
      //Sleep(2);
			//echo 'DELETING TEMP FILES: ' . $fname_fullpath_wikiout.'2';
			if (file_exists($fname_fullpath_wikiout))
				unlink($fname_fullpath_wikiout);
			if (file_exists($fname_fullpath_wikiout.'2'))
				unlink($fname_fullpath_wikiout.'2');
			if (file_exists($fname_fullpath.'4wiki'))
				unlink($fname_fullpath.'4wiki');
			}
		}


	// save it
	$fileo['contents']=$contents;

	// success
	return TRUE;
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
function mw_MassageWikiFileText(&$fileo)
{
	// base mediawiki version of this function does some generic pre-processing, adds category stuff

	$contents=$fileo['contents'];
	//
	$prefix = $this->addvalwithnewline($this->options['mw_header']);
	$suffix = $this->addvalwithnewline($this->options['mw_footer']);

	// specific categories
	if (!empty($this->options['mw_category']) && $this->options['mw_category']!="")
		{
		$cat_text = $this->options['mw_category'];
		$prefix .= '[[Category:' . $cat_text . ']]' . "\n";
		}

	// now categories based on directory
	// ATTN: unfinished

	// first get relative path, not including filename
	$dirpath = $fileo['fname_relpath'];
	$dirpath = str_replace('\\','/',$dirpath);
	$dirpathparts = explode('/',$dirpath);
	// remove the last item, which is filename
	unset($dirpathparts[count($dirpathparts)-1]);

	if ($this->arraypropenabled($this->options,'mw_dircat_top'))
		{
		$topcat = $this->options['mw_dircat_top'];
		}
	else
		$topcat = '';
	if ($this->arraypropenabled($this->options,'mw_dircat_subdir'))
		{
		// just most recent subdirectory as the category (or $topdir if at top)
		if (count($dirpathparts)>0)
			$prefix .= '[[Category:' . $dirpathparts[count($dirpathparts)-1] . ']]' . "\n";
		else if ($topcat!='')
			$prefix .= '[[Category:' . $topcat . ']]' . "\n";			
		}
	if ($this->arraypropenabled($this->options,'mw_dircat_fullpath'))
		{
		// the full path as a.b.c for subdirectory depth
		$subpath='';
		if (count($dirpathparts)>0)
			$subpath .= implode('.',$dirpathparts);
		if ($topcat!='')
			{
			if ($subpath!='')
				$subpath = $topcat . '.' . $subpath;
			else
				$subpath = $topcat;
			}
		if ($subpath!='')
			$prefix .= '[[Category:' . $subpath . ']]' . "\n";			
		}
	if ($this->arraypropenabled($this->options,'mw_dircat_sepdir'))
		{
		// add each subdirectory as a separate category
		if ($topcat!='')
			$prefix .= '[[Category:' . $topcat . ']]' . "\n";
		foreach ($dirpathparts as $onepath)
			{
			$prefix .= '[[Category:' . $onepath . ']]' . "\n";	
			}
		}


	$contents = $prefix . $contents . $suffix;
	$fileo['contents']=$contents;

	return TRUE;
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
function mw_SaveMassagedWikiFileText(&$fileo)
{
	// write out the changed file
	$contents=$fileo['contents'];
	$fname=$fileo['fname'];
	$fname_fullpath=$fileo['fname_fullpath'];
	$fname_relpath=$fileo['fname_relpath'];
	$extension=$fileo['extension'];

	// write it back out? -- good for testing
	if ($this->arraypropenabled($this->options,'mw_savewiki2') && !$this->arraypropenabled($this->options,'deletetempfiles'))
		{
		$fname_fullpath_wikiout = $fileo['fname_fullpath_wikiout'] . '2';
		file_put_contents($fname_fullpath_wikiout,$fileo['contents']);
		}

	// TEST
	// return FALSE;

	// success
	return TRUE;
}
//---------------------------------------------------------------------------























//---------------------------------------------------------------------------
function mw_titleFromFile($fileo)
{
	// by default the article title is taken from filename
	$fname_relpath=$fileo['fname_relpath'];
	$fileo_cached = $this->get_cachedfileo($fileo);

	if ($fileo_cached==NULL || !isset($fileo_cached['mwpagetitle']))
		{
		// no cached entry, get title from current
		return $this->mw_titleFromFile_Real( $fileo );
		}

	// cached, use this
	$this->AddInfoToLog(' using cached page title: "' . $fileo_cached['mwpagetitle'] . '"');
	return $fileo_cached['mwpagetitle'];
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
function mw_titleFromFile_Real($fileo) {
	// by default the article title is taken from filename
	return $this->mw_titleFromFile_PureLexical( $fileo );
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// mediawiki helpers

// from mediawiki/maintenance/importTextFile.php
function mw_titleFromFile_PureLexical( $fileo ) {

	$fname_relpath=$fileo['fname_relpath'];
	$extension=$fileo['extension'];

	$flag_shortimagefilenames = TRUE;

	if (false)
		{
		$parts = explode( '/', $fname_relpath );
		$parts = explode( '.', $parts[ count( $parts ) - 1 ] );
		return $parts[0];
		}
	else if ($flag_shortimagefilenames && in_array($extension,$this->def_extentions_image))
		{
		// images we just want by default the base name WITH extension; we may have lots of duplicate iniital default filename clashes that require renaming
		$titlename = basename($fname_relpath);
		return $titlename;
		}
	else
		{
		// strip extension
		$titlename=$fname_relpath;
		$lastdotpos = strrpos($titlename,'.');
		if ($lastdotpos!==FALSE)
			$titlename = substr($titlename,0,$lastdotpos);
		// change dir seps to _
		$titlename = str_replace('/','_',$titlename);
		$titlename = str_replace('\\','_',$titlename);

		// periods to something else?
		$titlename = $this->mw_correctbadfile2wikicharacters($titlename);

		//

		// add bad extension IFF its an image file(!)
		// this is when $flag_shortimagefilenames is false 
		if (in_array($extension,$this->def_extentions_image))
			{
			$titlename .= '.' . $extension;
			}

		$titlename = $this->options['mw_titleprefix'] . $titlename;

		return $titlename;
		}
}
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
function mw_correctbadfile2wikicharacters($str)
{
	//$str = str_replace('.','_',$str);
	//$str = str_replace(' ','_',$str);
	return $str;
}
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
function preg_callback_imagemapfix($matches)
{
	//echo 'DEBUG in preg_callback_imagemapfix:';
	//print_r($matches); 

	$repl = '<imagemap>' . "\n" . $matches[4] . "\n" . $matches[3] . '</imagemap>' . "\n";

	return $repl;
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
function mw_PreprocessHtmlFile(&$fileo)
{
	// here we can create a new html file based on imput one, (dont use an html extension or it will get found for input processing!)
  // if we do, set $fileo['fname_fullpath_inputhtml'] to output filename of modified html

	// here we can create a new html file based on imput one, (dont use an html extension or it will get found for input processing!)
  // if we do, set $fileo['fname_fullpath_inputhtml'] to output filename of modified html

	// filename for modified file
	$fname_fullpath=$fileo['fname_fullpath'];
	$fname_fullpath_inputhtml = $fname_fullpath . "4wiki";

	$htmlcontents = file_get_contents($fname_fullpath);
	$htmlcontents_orig=$htmlcontents;

  // now modify
  $retv = $this->mw_PreprocessHtmlFile_Modify($fileo,$htmlcontents);

	// abort?
	if ($retv===false || $htmlcontents=="")
		return false;

	if ($htmlcontents_orig==$htmlcontents)
		{
		// unchanged, use original
		return true;
		}

  // save and tell converter to use converted file
	file_put_contents($fname_fullpath_inputhtml,$htmlcontents);
	$fileo['fname_fullpath_inputhtml']=$fname_fullpath_inputhtml;

	// success
	return true;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function mw_PreprocessHtmlFile_Modify(&$fileo,&$htmlcontents)
{
	// modify contents, then write contents to outfname_fullpath, then save in $fileo['fname_fullpath_inputhtml']
  // or do nothing and processor will use original html file
	// just change the htmlcontents if you want to use the new contents, or leave contents alone if you want to use the original html file
	// return false to abort conversion of the file completely


	// now fixup all "<a href="">" and "<img " links that we can
	$this->mw_FixupLocalLinks($htmlcontents,$fileo);


	return true;
}
//---------------------------------------------------------------------------




















//---------------------------------------------------------------------------
function BeforeRun()
{
	// do any stuff before main run
	parent::BeforeRun();
}


function AfterRun()
{
	// do any stuff after main run
	parent::AfterRun();

	// kill mediawiki cache
	$dbw = wfGetDB( DB_MASTER );
	list ($objectcachetable) = $dbw->tableNamesN( 'objectcache' );

	if ($objectcachetable=='')
		{
		echo 'ERROR: could not get name of objectcache table.' . "\n";
		return false;
		}

	echo 'Mediawiki operation: trying to clear mediawiki cache table: ' . $objectcachetable . "\n";
	$res = $dbw->query( "truncate table " .  $objectcachetable );
	//echo 'RESULT: ';
	//print_r($res);
	return true;
}
//---------------------------------------------------------------------------











































//---------------------------------------------------------------------------
function PreProcessFile($fileo)
{
	// this is optional
	// in phase 1 the PreProcess file function gets called for every file, before any converting is done
	// in phase 2 we convert
	// this lets us make a map of all filenames for advanced processing
	//
	//$this->AddToLog(array('type'=>'info','text'=>'PreProcessing file "' . $fileo['fname_fullpath'] . '".'));

	//
	$fname=$fileo['fname'];
	$fname_fullpath=$fileo['fname_fullpath'];
	$fname_relpath=$fileo['fname_relpath'];
	$extension=$fileo['extension'];

	// ATTN: todo 5/16/10
	// this has to be updated to deal with duplicate page titles

	// ok lets add the page TITLE to $fileo
	//  note that we always store the pure lexical default title
	//  but then allow that derived class may have more advanced way to choose a title
	$fileo['mwpagetitle_purelexical']=$this->mw_titleFromFile_PureLexical($fileo);

	// ok now the article/page official title
	// if there is already a file with this title, then we will add path info to differentiate it
	$mwpagetitle = $this->mw_titleFromFile($fileo);
	$existingfileo = $this->find_cachedfileo_bymwpagetitle($mwpagetitle);
	if ($existingfileo!=NULL)
		{
		// another file has this title, so modify it
		//echo 'DEBUG: Warning - preprocessing file  [' . $fileo['fname_relpath'] . '] with desired title ' . $mwpagetitle .' has same title as [' . $existingfileo['fname_relpath'] . ']' . "\n";
		// ok, we need try to a dif title
		$mwpagetitlealt = $this->pathprefix($fname_relpath,true) . '_' . $mwpagetitle;
		// now test again and try numeric offset suffix if this fails?
		$postfixnum = 1;
		while ($this->find_cachedfileo_bymwpagetitle($mwpagetitlealt)!=NULL)
			{
			$mwpagetitlealt = $mwpagetitle . $postfixnum;
			++$postfixnum;
			}
		// ok set new filename
		$mwpagetitle=$mwpagetitlealt;
		}
	$fileo['mwpagetitle']=$mwpagetitle;
	//echo 'DEBUG: cache into [' . $fileo['fname_relpath'] . '] = ' . $fileo['mwpagetitle'] . "\n";

	// now let parent store fileo in $filenametitlemap
	parent::PreProcessFile($fileo);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function pathprefix($fname_relpath,$flag_doconvertslahestospaces)
{
	// return just the relative path, with _ for / and no filename
	// first change all \\ to /
	$str = str_replace('\\','/',$fname_relpath);
	// now remove last
	$rpos = strrpos($str,'/');
	if ($rpos!==FALSE)
		{
		$str = substr($str,0,$rpos);
		}
	else
		$str = '';
	// now replace / with _
	if ($flag_doconvertslahestospaces)
		$str = str_replace('/','_',$str);
	return $str;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
function find_cachedfileo_bywikifilenamelink($filenametitle)
{
	foreach ($this->filenametitlemap as $onefnamemap)
		{
		if ($onefnamemap['mwpagetitle_purelexical']==$filenametitle)
			return $onefnamemap;
		}
	return NULL;
}


function find_cachedfileo_bywikifilenamelink_canonical($filenametitle)
{
	//
	//echo '!!! LOOKING FOR ' . $filenametitle . ': ' . "\n";
	foreach ($this->filenametitlemap as $onefnamemap)
		{
		$fname_relpath = $onefnamemap['fname_relpath'];
		//echo '!!!! CHECKING AGAINST: ' . $fname_relpath . "\n";
		if ($fname_relpath==$filenametitle)
			return $onefnamemap;
		}
		//echo '!!!! NOT FOUND.' . "\n";
	return NULL;
}


function find_cachedfileo_bymwpagetitle($pagetitle)
{
	// ATTN: todo 5/16/10
	// will this work with duplicate filenames
	foreach ($this->filenametitlemap as $onefnamemap)
		{
		if ($onefnamemap['mwpagetitle']==$pagetitle)
			return $onefnamemap;
		}
	return NULL;
}
//---------------------------------------------------------------------------













//---------------------------------------------------------------------------
function mw_FixupLocalLinks(&$contents,$fileo)
{
	// now fixup all "<a href="">" and "<img " links that we can
	// by changing from a relative path to absolute mwpagetitle names

	// loop through all links and replace on them

	//echo 'ATTN: ####################### IN mw_FixupLocalLinks SEARCHING ' . $contents . "\n";

	// save this for callback
	$this->last_linkfixing_fileo = $fileo;

	// of form <a ... href="" .. >
	$pat = "/(\<a\s[^\>]*\s*href\s*\=\s*\")([^\"]*)(\"[^\>]*\>)/i";
	$contents = preg_replace_callback($pat,array( &$this, 'mw_FixupLocalLink_Callback'),$contents);

	// of form <img .. src="" ..>
	$pat = "/(\<img\s[^\>]*\s*src\s*\=\s*\")([^\"]*)(\"[^\>]*\>)/i";
	$contents = preg_replace_callback($pat,array( &$this, 'mw_FixupLocalLink_Callback'),$contents);

	//echo 'CONTENTS AFTER mw_FixupLocalLinks are: ' . $contents . "\n";
}




function mw_FixupLocalLink_Callback($matches)
{
	$linkurl = $matches[2];
	$linkurl_fixed = $this->mw_FixupLocalLink($linkurl);

	// ok and now we change it to the mw title page name if we can find it!
	$canonicalfileo = $this->find_cachedfileo_bywikifilenamelink_canonical($linkurl_fixed);
	if ($canonicalfileo===NULL)
		{
		// not found, use as is
		}
	else
		{
		$mwpagetitle = $canonicalfileo['mwpagetitle'];
		$linkurl_fixed = $mwpagetitle;
		// it's important for links that we have a file extension not just the title; this will already be on image files but NOT on links
		$extension=$canonicalfileo['extension'];
		if (!in_array($extension,$this->def_extentions_image))
			{
			// add extension from file to title for link
			$linkurl_fixed .= '.' . $extension;
			}
		// force ' ' to '_'
		$linkurl_fixed=str_replace(' ','_',$linkurl_fixed);
		}

	$newexpression = $matches[1] . $linkurl_fixed . $matches[3];
	//echo 'DEBUG fixed link' . "\n" . ' *FROM: ' . $linkurl . "\n" . ' *TO ' . $linkurl_fixed . "\n";
	return $newexpression;
}



function mw_FixupLocalLink($link_orig)
{
	// now fixup all "<a href="">" and "<img " links that we can
	// by changing from a relative path to absolute mwpagetitle names
	$link_fixed = $link_orig;

	// ok now given this link, we want to see if we can find it in our local set, if not retuen it unchanged.
	// first things first, if it starts with # or has "tp://" in it, then its not something we can fix up
	// ATTN: though in the future we may want to auto-convert some urls
	if ($link_orig=="")
		return $link_orig;
	if ($link_orig[0]=='#')
		return $link_orig;
	if (strpos($link_orig,"tp://")!==FALSE)
		return $link_orig;

	// ok so it's a link that is relative to the site (if it starts with /) or to our current page if not
	// get current page info
	$fileo = $this->last_linkfixing_fileo;
	
	// ok so what we want to do first is combine the path to the current page with any relative adjustment in the link
	// so.. if the link is /blah then its relative to our BASE path ("/" or "")
	//  if the link is "../blah.html" and our current page is a/b/c.html then we want to change it to "a/blah.html"
	//  if the link is "d/blah.html" our our current page is a/b/c.html then we want to change it to "a/b/d/blah.html"
	
	// first lets get our current PATH (not file)
	$fname_relpath=$fileo['fname_relpath'];	
	$curpath = $this->pathprefix($fname_relpath,false);
	$basepath = '';

	// ok now lets combine current with link and base
	$link_fixed = $this->mw_AdjustLinkToBaseAndCurrentPath($link_orig,$curpath,$basepath);

	return $link_fixed;
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
function mw_AdjustLinkToBaseAndCurrentPath($link,$curpath,$basepath)
{
	// ok so what we want to do first is combine the path to the current page with any relative adjustment in the link
	// so.. if the link is /blah then its relative to our BASE path ("/" or "")
	//  if the link is "../blah.html" and our current page is a/b/c.html then we want to change it to "a/blah.html"
	//  if the link is "d/blah.html" our our current page is a/b/c.html then we want to change it to "a/b/d/blah.html"

	// first change all \\ to /
	$link = str_replace('\\','/',$link);
	$curpath = str_replace('\\','/',$curpath);
	$basepath = str_replace('\\','/',$basepath);

	// first let's fix up curpath (if it ends in / then remove it, same with basepath)
	$len = strlen($curpath);
	if ($len>0 && $curpath[$len-1]=='/')
		$curpath=substr($curpath,0,$len-1);
	$len = strlen($basepath);
	if ($len>0 && $basepath[$len-1]=='/')
		$basepath=substr($basepath,0,$len-1);
	$len = strlen($link);
	if ($len>0 && $link[$len-1]=='/')
		$link=substr($link,0,$len-1);

	// starts at root?
	$len = strlen($link);
	if ($len>0 && $link[0]=='/')
		{
		// starting off at root, not curpath
		$curpath='';
		$link=substr($link,1,$len-1);
		}
		
	// we are going to start with curpath and then adjust as we parse split versions of $link
	$linkparts=explode('/',$link);
	$workpath=$curpath;

	//echo '  *WORKPATH IS: ' . $workpath . "\n";

	foreach ($linkparts as $linkpart)
		{
		if ($linkpart=='..')
			{
			// pop up one from workpath
			$rpos =strrpos($workpath,'/');
			if ($rpos!==FALSE)
				{
				if ($rpos===0)
					$workpath='';
				else
					$workpath=substr($workpath,0,$rpos-1);
				}
			else
				$workpath='';
			}
		else
			{
			// add part to working path
			if ($workpath!='')
				$workpath .= '/';
			$workpath .= $linkpart;
			}
		}

	// ok the found path is workpath
	return $workpath;
}
//---------------------------------------------------------------------------








}